///
/// Copyright (c) 2016 Dropbox, Inc. All rights reserved.
///
/// Auto-generated by Stone, do not modify.
///

#import <Foundation/Foundation.h>

#import "DBSerializableProtocol.h"

@class DBFILESGetTagsResult;
@class DBFILESPathToTags;

NS_ASSUME_NONNULL_BEGIN

#pragma mark - API Object

///
/// The `GetTagsResult` struct.
///
/// This class implements the `DBSerializable` protocol (serialize and
/// deserialize instance methods), which is required for all Obj-C SDK API route
/// objects.
///
@interface DBFILESGetTagsResult : NSObject <DBSerializable, NSCopying>

#pragma mark - Instance fields

/// List of paths and their corresponding tags.
@property (nonatomic, readonly) NSArray<DBFILESPathToTags *> *pathsToTags;

#pragma mark - Constructors

///
/// Full constructor for the struct (exposes all instance variables).
///
/// @param pathsToTags List of paths and their corresponding tags.
///
/// @return An initialized instance.
///
- (instancetype)initWithPathsToTags:(NSArray<DBFILESPathToTags *> *)pathsToTags;

- (instancetype)init NS_UNAVAILABLE;

@end

#pragma mark - Serializer Object

///
/// The serialization class for the `GetTagsResult` struct.
///
@interface DBFILESGetTagsResultSerializer : NSObject

///
/// Serializes `DBFILESGetTagsResult` instances.
///
/// @param instance An instance of the `DBFILESGetTagsResult` API object.
///
/// @return A json-compatible dictionary representation of the
/// `DBFILESGetTagsResult` API object.
///
+ (nullable NSDictionary<NSString *, id> *)serialize:(DBFILESGetTagsResult *)instance;

///
/// Deserializes `DBFILESGetTagsResult` instances.
///
/// @param dict A json-compatible dictionary representation of the
/// `DBFILESGetTagsResult` API object.
///
/// @return An instantiation of the `DBFILESGetTagsResult` object.
///
+ (DBFILESGetTagsResult *)deserialize:(NSDictionary<NSString *, id> *)dict;

@end

NS_ASSUME_NONNULL_END
