///
/// Copyright (c) 2016 Dropbox, Inc. All rights reserved.
///
/// Auto-generated by Stone, do not modify.
///

#import <Foundation/Foundation.h>

#import "DBPAPERRefPaperDoc.h"
#import "DBSerializableProtocol.h"

@class DBPAPERListUsersOnFolderContinueArgs;

NS_ASSUME_NONNULL_BEGIN

#pragma mark - API Object

///
/// The `ListUsersOnFolderContinueArgs` struct.
///
/// This class implements the `DBSerializable` protocol (serialize and
/// deserialize instance methods), which is required for all Obj-C SDK API route
/// objects.
///
@interface DBPAPERListUsersOnFolderContinueArgs : DBPAPERRefPaperDoc <DBSerializable, NSCopying>

#pragma mark - Instance fields

/// The cursor obtained from `docsFolderUsersList` or
/// `docsFolderUsersListContinue`. Allows for pagination.
@property (nonatomic, readonly, copy) NSString *cursor;

#pragma mark - Constructors

///
/// Full constructor for the struct (exposes all instance variables).
///
/// @param docId The Paper doc ID.
/// @param cursor The cursor obtained from `docsFolderUsersList` or
/// `docsFolderUsersListContinue`. Allows for pagination.
///
/// @return An initialized instance.
///
- (instancetype)initWithDocId:(NSString *)docId cursor:(NSString *)cursor;

@end

#pragma mark - Serializer Object

///
/// The serialization class for the `ListUsersOnFolderContinueArgs` struct.
///
@interface DBPAPERListUsersOnFolderContinueArgsSerializer : NSObject

///
/// Serializes `DBPAPERListUsersOnFolderContinueArgs` instances.
///
/// @param instance An instance of the `DBPAPERListUsersOnFolderContinueArgs`
/// API object.
///
/// @return A json-compatible dictionary representation of the
/// `DBPAPERListUsersOnFolderContinueArgs` API object.
///
+ (nullable NSDictionary<NSString *, id> *)serialize:(DBPAPERListUsersOnFolderContinueArgs *)instance;

///
/// Deserializes `DBPAPERListUsersOnFolderContinueArgs` instances.
///
/// @param dict A json-compatible dictionary representation of the
/// `DBPAPERListUsersOnFolderContinueArgs` API object.
///
/// @return An instantiation of the `DBPAPERListUsersOnFolderContinueArgs`
/// object.
///
+ (DBPAPERListUsersOnFolderContinueArgs *)deserialize:(NSDictionary<NSString *, id> *)dict;

@end

NS_ASSUME_NONNULL_END
