///
/// Copyright (c) 2016 Dropbox, Inc. All rights reserved.
///
/// Auto-generated by Stone, do not modify.
///

#import <Foundation/Foundation.h>

#import "DBSerializableProtocol.h"

@class DBSHARINGAlphaResolvedVisibility;
@class DBSHARINGRequestedVisibility;
@class DBSHARINGVisibilityPolicy;
@class DBSHARINGVisibilityPolicyDisallowedReason;

NS_ASSUME_NONNULL_BEGIN

#pragma mark - API Object

///
/// The `VisibilityPolicy` struct.
///
/// This class implements the `DBSerializable` protocol (serialize and
/// deserialize instance methods), which is required for all Obj-C SDK API route
/// objects.
///
@interface DBSHARINGVisibilityPolicy : NSObject <DBSerializable, NSCopying>

#pragma mark - Instance fields

/// This is the value to submit when saving the visibility setting.
@property (nonatomic, readonly) DBSHARINGRequestedVisibility *policy;

/// This is what the effective policy would be, if you selected this option. The
/// resolved policy is obtained after considering external effects such as
/// shared folder settings and team policy. This value is guaranteed to be
/// provided.
@property (nonatomic, readonly) DBSHARINGAlphaResolvedVisibility *resolvedPolicy;

/// Whether the user is permitted to set the visibility to this policy.
@property (nonatomic, readonly) NSNumber *allowed;

/// If allowed is false, this will provide the reason that the user is not
/// permitted to set the visibility to this policy.
@property (nonatomic, readonly, nullable) DBSHARINGVisibilityPolicyDisallowedReason *disallowedReason;

#pragma mark - Constructors

///
/// Full constructor for the struct (exposes all instance variables).
///
/// @param policy This is the value to submit when saving the visibility
/// setting.
/// @param resolvedPolicy This is what the effective policy would be, if you
/// selected this option. The resolved policy is obtained after considering
/// external effects such as shared folder settings and team policy. This value
/// is guaranteed to be provided.
/// @param allowed Whether the user is permitted to set the visibility to this
/// policy.
/// @param disallowedReason If allowed is false, this will provide the reason
/// that the user is not permitted to set the visibility to this policy.
///
/// @return An initialized instance.
///
- (instancetype)initWithPolicy:(DBSHARINGRequestedVisibility *)policy
                resolvedPolicy:(DBSHARINGAlphaResolvedVisibility *)resolvedPolicy
                       allowed:(NSNumber *)allowed
              disallowedReason:(nullable DBSHARINGVisibilityPolicyDisallowedReason *)disallowedReason;

///
/// Convenience constructor (exposes only non-nullable instance variables with
/// no default value).
///
/// @param policy This is the value to submit when saving the visibility
/// setting.
/// @param resolvedPolicy This is what the effective policy would be, if you
/// selected this option. The resolved policy is obtained after considering
/// external effects such as shared folder settings and team policy. This value
/// is guaranteed to be provided.
/// @param allowed Whether the user is permitted to set the visibility to this
/// policy.
///
/// @return An initialized instance.
///
- (instancetype)initWithPolicy:(DBSHARINGRequestedVisibility *)policy
                resolvedPolicy:(DBSHARINGAlphaResolvedVisibility *)resolvedPolicy
                       allowed:(NSNumber *)allowed;

- (instancetype)init NS_UNAVAILABLE;

@end

#pragma mark - Serializer Object

///
/// The serialization class for the `VisibilityPolicy` struct.
///
@interface DBSHARINGVisibilityPolicySerializer : NSObject

///
/// Serializes `DBSHARINGVisibilityPolicy` instances.
///
/// @param instance An instance of the `DBSHARINGVisibilityPolicy` API object.
///
/// @return A json-compatible dictionary representation of the
/// `DBSHARINGVisibilityPolicy` API object.
///
+ (nullable NSDictionary<NSString *, id> *)serialize:(DBSHARINGVisibilityPolicy *)instance;

///
/// Deserializes `DBSHARINGVisibilityPolicy` instances.
///
/// @param dict A json-compatible dictionary representation of the
/// `DBSHARINGVisibilityPolicy` API object.
///
/// @return An instantiation of the `DBSHARINGVisibilityPolicy` object.
///
+ (DBSHARINGVisibilityPolicy *)deserialize:(NSDictionary<NSString *, id> *)dict;

@end

NS_ASSUME_NONNULL_END
