///
/// Copyright (c) 2016 Dropbox, Inc. All rights reserved.
///
/// Auto-generated by Stone, do not modify.
///

#import <Foundation/Foundation.h>

#import "DBSerializableProtocol.h"

@class DBTEAMLOGComputerBackupPolicy;
@class DBTEAMLOGComputerBackupPolicyChangedDetails;

NS_ASSUME_NONNULL_BEGIN

#pragma mark - API Object

///
/// The `ComputerBackupPolicyChangedDetails` struct.
///
/// Changed computer backup policy for team.
///
/// This class implements the `DBSerializable` protocol (serialize and
/// deserialize instance methods), which is required for all Obj-C SDK API route
/// objects.
///
@interface DBTEAMLOGComputerBackupPolicyChangedDetails : NSObject <DBSerializable, NSCopying>

#pragma mark - Instance fields

/// New computer backup policy.
@property (nonatomic, readonly) DBTEAMLOGComputerBackupPolicy *dNewValue;

/// Previous computer backup policy.
@property (nonatomic, readonly) DBTEAMLOGComputerBackupPolicy *previousValue;

#pragma mark - Constructors

///
/// Full constructor for the struct (exposes all instance variables).
///
/// @param dNewValue New computer backup policy.
/// @param previousValue Previous computer backup policy.
///
/// @return An initialized instance.
///
- (instancetype)initWithDNewValue:(DBTEAMLOGComputerBackupPolicy *)dNewValue
                    previousValue:(DBTEAMLOGComputerBackupPolicy *)previousValue;

- (instancetype)init NS_UNAVAILABLE;

@end

#pragma mark - Serializer Object

///
/// The serialization class for the `ComputerBackupPolicyChangedDetails` struct.
///
@interface DBTEAMLOGComputerBackupPolicyChangedDetailsSerializer : NSObject

///
/// Serializes `DBTEAMLOGComputerBackupPolicyChangedDetails` instances.
///
/// @param instance An instance of the
/// `DBTEAMLOGComputerBackupPolicyChangedDetails` API object.
///
/// @return A json-compatible dictionary representation of the
/// `DBTEAMLOGComputerBackupPolicyChangedDetails` API object.
///
+ (nullable NSDictionary<NSString *, id> *)serialize:(DBTEAMLOGComputerBackupPolicyChangedDetails *)instance;

///
/// Deserializes `DBTEAMLOGComputerBackupPolicyChangedDetails` instances.
///
/// @param dict A json-compatible dictionary representation of the
/// `DBTEAMLOGComputerBackupPolicyChangedDetails` API object.
///
/// @return An instantiation of the
/// `DBTEAMLOGComputerBackupPolicyChangedDetails` object.
///
+ (DBTEAMLOGComputerBackupPolicyChangedDetails *)deserialize:(NSDictionary<NSString *, id> *)dict;

@end

NS_ASSUME_NONNULL_END
