///
/// Copyright (c) 2016 Dropbox, Inc. All rights reserved.
///
/// Auto-generated by Stone, do not modify.
///

#import <Foundation/Foundation.h>

#import "DBSerializableProtocol.h"

@class DBTEAMLOGLogoutDetails;

NS_ASSUME_NONNULL_BEGIN

#pragma mark - API Object

///
/// The `LogoutDetails` struct.
///
/// Signed out.
///
/// This class implements the `DBSerializable` protocol (serialize and
/// deserialize instance methods), which is required for all Obj-C SDK API route
/// objects.
///
@interface DBTEAMLOGLogoutDetails : NSObject <DBSerializable, NSCopying>

#pragma mark - Instance fields

/// Login session id.
@property (nonatomic, readonly, copy, nullable) NSString *loginId;

#pragma mark - Constructors

///
/// Full constructor for the struct (exposes all instance variables).
///
/// @param loginId Login session id.
///
/// @return An initialized instance.
///
- (instancetype)initWithLoginId:(nullable NSString *)loginId;

///
/// Convenience constructor (exposes only non-nullable instance variables with
/// no default value).
///
///
/// @return An initialized instance.
///
- (instancetype)initDefault;

- (instancetype)init NS_UNAVAILABLE;

@end

#pragma mark - Serializer Object

///
/// The serialization class for the `LogoutDetails` struct.
///
@interface DBTEAMLOGLogoutDetailsSerializer : NSObject

///
/// Serializes `DBTEAMLOGLogoutDetails` instances.
///
/// @param instance An instance of the `DBTEAMLOGLogoutDetails` API object.
///
/// @return A json-compatible dictionary representation of the
/// `DBTEAMLOGLogoutDetails` API object.
///
+ (nullable NSDictionary<NSString *, id> *)serialize:(DBTEAMLOGLogoutDetails *)instance;

///
/// Deserializes `DBTEAMLOGLogoutDetails` instances.
///
/// @param dict A json-compatible dictionary representation of the
/// `DBTEAMLOGLogoutDetails` API object.
///
/// @return An instantiation of the `DBTEAMLOGLogoutDetails` object.
///
+ (DBTEAMLOGLogoutDetails *)deserialize:(NSDictionary<NSString *, id> *)dict;

@end

NS_ASSUME_NONNULL_END
