///
/// Copyright (c) 2016 Dropbox, Inc. All rights reserved.
///
/// Auto-generated by Stone, do not modify.
///

#import <Foundation/Foundation.h>

#import "DBSerializableProtocol.h"

@class DBTEAMLOGTeamExtensionsPolicy;
@class DBTEAMLOGTeamExtensionsPolicyChangedDetails;

NS_ASSUME_NONNULL_BEGIN

#pragma mark - API Object

///
/// The `TeamExtensionsPolicyChangedDetails` struct.
///
/// Changed App Integrations setting for team.
///
/// This class implements the `DBSerializable` protocol (serialize and
/// deserialize instance methods), which is required for all Obj-C SDK API route
/// objects.
///
@interface DBTEAMLOGTeamExtensionsPolicyChangedDetails : NSObject <DBSerializable, NSCopying>

#pragma mark - Instance fields

/// New Extensions policy.
@property (nonatomic, readonly) DBTEAMLOGTeamExtensionsPolicy *dNewValue;

/// Previous Extensions policy.
@property (nonatomic, readonly) DBTEAMLOGTeamExtensionsPolicy *previousValue;

#pragma mark - Constructors

///
/// Full constructor for the struct (exposes all instance variables).
///
/// @param dNewValue New Extensions policy.
/// @param previousValue Previous Extensions policy.
///
/// @return An initialized instance.
///
- (instancetype)initWithDNewValue:(DBTEAMLOGTeamExtensionsPolicy *)dNewValue
                    previousValue:(DBTEAMLOGTeamExtensionsPolicy *)previousValue;

- (instancetype)init NS_UNAVAILABLE;

@end

#pragma mark - Serializer Object

///
/// The serialization class for the `TeamExtensionsPolicyChangedDetails` struct.
///
@interface DBTEAMLOGTeamExtensionsPolicyChangedDetailsSerializer : NSObject

///
/// Serializes `DBTEAMLOGTeamExtensionsPolicyChangedDetails` instances.
///
/// @param instance An instance of the
/// `DBTEAMLOGTeamExtensionsPolicyChangedDetails` API object.
///
/// @return A json-compatible dictionary representation of the
/// `DBTEAMLOGTeamExtensionsPolicyChangedDetails` API object.
///
+ (nullable NSDictionary<NSString *, id> *)serialize:(DBTEAMLOGTeamExtensionsPolicyChangedDetails *)instance;

///
/// Deserializes `DBTEAMLOGTeamExtensionsPolicyChangedDetails` instances.
///
/// @param dict A json-compatible dictionary representation of the
/// `DBTEAMLOGTeamExtensionsPolicyChangedDetails` API object.
///
/// @return An instantiation of the
/// `DBTEAMLOGTeamExtensionsPolicyChangedDetails` object.
///
+ (DBTEAMLOGTeamExtensionsPolicyChangedDetails *)deserialize:(NSDictionary<NSString *, id> *)dict;

@end

NS_ASSUME_NONNULL_END
