///
/// Copyright (c) 2016 Dropbox, Inc. All rights reserved.
///
/// Auto-generated by Stone, do not modify.
///

#import <Foundation/Foundation.h>

#import "DBSerializableProtocol.h"

@class DBTEAMLOGWatermarkingPolicy;
@class DBTEAMLOGWatermarkingPolicyChangedDetails;

NS_ASSUME_NONNULL_BEGIN

#pragma mark - API Object

///
/// The `WatermarkingPolicyChangedDetails` struct.
///
/// Changed watermarking policy for team.
///
/// This class implements the `DBSerializable` protocol (serialize and
/// deserialize instance methods), which is required for all Obj-C SDK API route
/// objects.
///
@interface DBTEAMLOGWatermarkingPolicyChangedDetails : NSObject <DBSerializable, NSCopying>

#pragma mark - Instance fields

/// New watermarking policy.
@property (nonatomic, readonly) DBTEAMLOGWatermarkingPolicy *dNewValue;

/// Previous watermarking policy.
@property (nonatomic, readonly) DBTEAMLOGWatermarkingPolicy *previousValue;

#pragma mark - Constructors

///
/// Full constructor for the struct (exposes all instance variables).
///
/// @param dNewValue New watermarking policy.
/// @param previousValue Previous watermarking policy.
///
/// @return An initialized instance.
///
- (instancetype)initWithDNewValue:(DBTEAMLOGWatermarkingPolicy *)dNewValue
                    previousValue:(DBTEAMLOGWatermarkingPolicy *)previousValue;

- (instancetype)init NS_UNAVAILABLE;

@end

#pragma mark - Serializer Object

///
/// The serialization class for the `WatermarkingPolicyChangedDetails` struct.
///
@interface DBTEAMLOGWatermarkingPolicyChangedDetailsSerializer : NSObject

///
/// Serializes `DBTEAMLOGWatermarkingPolicyChangedDetails` instances.
///
/// @param instance An instance of the
/// `DBTEAMLOGWatermarkingPolicyChangedDetails` API object.
///
/// @return A json-compatible dictionary representation of the
/// `DBTEAMLOGWatermarkingPolicyChangedDetails` API object.
///
+ (nullable NSDictionary<NSString *, id> *)serialize:(DBTEAMLOGWatermarkingPolicyChangedDetails *)instance;

///
/// Deserializes `DBTEAMLOGWatermarkingPolicyChangedDetails` instances.
///
/// @param dict A json-compatible dictionary representation of the
/// `DBTEAMLOGWatermarkingPolicyChangedDetails` API object.
///
/// @return An instantiation of the `DBTEAMLOGWatermarkingPolicyChangedDetails`
/// object.
///
+ (DBTEAMLOGWatermarkingPolicyChangedDetails *)deserialize:(NSDictionary<NSString *, id> *)dict;

@end

NS_ASSUME_NONNULL_END
